
Imports System.Data.OleDb
Imports System.Drawing.Drawing2D
Public Class Eingabe
    Private ds As New DataSet
    Private connString As String
    Private da As OleDb.OleDbDataAdapter
    Private dv As DataView
    Private objCB As OleDb.OleDbCommandBuilder
    Private ds1 As New DataSet
    Private connString1 As String
    Private da1 As OleDb.OleDbDataAdapter
    Private dv1 As DataView


 

    Private Sub Eingabe_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Left = CInt((Screen.PrimaryScreen.WorkingArea.Width - Me.Width) / 2)
        Me.Top = CInt((Screen.PrimaryScreen.WorkingArea.Height - Me.Height) / 2)

        Lade_DB()
        Zahlzeigen()
    End Sub
    ' Hintergrund-Farbverlauf erstellen
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        ' Gre der Form
        Dim oRect As New Rectangle(0, 0, Me.Width, Me.Height)

        ' Neues Brush-Objekt mit den gewnschten Farben und 
        ' Farbverlauf-Richtung erstellen
        Dim oBrush As New LinearGradientBrush(oRect, Color.White, Color.Black, _
          LinearGradientMode.ForwardDiagonal)

        ' Hintergrund-Farbverlauf anzeigen
        e.Graphics.FillRectangle(oBrush, oRect)

        Dim fnt As New Font("Serifa BT", 8)
        Dim text As String = "Maximal 20 Zeichen "
        Dim offset As Integer = 1
        Dim g As Graphics = e.Graphics

        g.TranslateTransform(-offset, 25)


        ' Anhebung zeichnen
        g.DrawString(text, fnt, Brushes.Black, 40, -10)

        ' Normalbereich zeichnen
        g.TranslateTransform(-offset, -offset)
        g.DrawString(text, fnt, Brushes.Red, 40, -10)


    End Sub
    Private Sub Zahlzeigen()
        Me.Label1.Text = (((Me.BindingContext(dv).Position + 1).ToString + " von  ") _
                    + Me.BindingContext(dv).Count.ToString)

    End Sub

    Private Sub Lade_DB()
        connString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Application.StartupPath & "\Hnger.mdb"

        Dim conn As New OleDb.OleDbConnection(connString)
        Dim sql As String = "SELECT * FROM Worte ORDER BY ID"
        da = New OleDb.OleDbDataAdapter(sql, conn)
        Dim cb As New OleDb.OleDbCommandBuilder(da)

        Try

            da.Fill(ds, "Worte")
        Catch ex As System.Exception
            MsgBox(ex.ToString())
            Return
        End Try
        dv = ds.Tables("Worte").DefaultView

        DataGridView1.DataSource = dv
        DataGridView1.Columns.Remove("ID")
        DataGridView1.Columns.Remove("Zufall")


        TextBox1.DataBindings.Add("Text", dv, "Begriff")
        TextBox2.DataBindings.Add("Text", dv, "Zufall")
        TextBox3.DataBindings.Add("Text", dv, "ID")


    End Sub



    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        'Entfernt Leerzeichen an Anfang und am Ende
        TextBox1.Text = Trim(TextBox1.Text)



        'Erzwingt die fr den Hangman erforderliche Groschreibung
        TextBox1.Text = UCase(TextBox1.Text)

        objCB = New OleDb.OleDbCommandBuilder(da)
        da.UpdateCommand = objCB.GetUpdateCommand

        Try
            Me.BindingContext(dv).EndCurrentEdit()

            Dim m As Integer = da.Update(ds, "Worte")
            MessageBox.Show((m.ToString & " Begriff gendert!"), _
              "nderungen erfolgreich bernommen!", MessageBoxButtons.OK, MessageBoxIcon.Information)
            da.Update(ds, "Worte")

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Fehler beim Update!", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
        Zahlzeigen()

    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim msg As String
        Dim title As String
        Dim style As MsgBoxStyle
        Dim response As MsgBoxResult
        msg = "Wollen Sie den Datensatz  " & TextBox1.Text & "  wirklich lschen?"
        style = MsgBoxStyle.DefaultButton2 Or _
           MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
        title = "Lschen"
        response = MsgBox(msg, style, title)
        If response = MsgBoxResult.Yes Then

            If (Me.BindingContext(dv).Count > 0) Then
                Me.BindingContext(dv).RemoveAt(Me.BindingContext(dv).Position)

            End If

            Try
                'Versuch, die Datenquelle zu aktualisieren.
                da.Update(ds, "Worte")
            Catch eUpdate As System.Exception
                'Fehlerbehandlungscode hier hinzufgen.
                'Fehlermeldung anzeigen, falls verfgbar.
                System.Windows.Forms.MessageBox.Show(eUpdate.Message)
            End Try

        End If
        If response = MsgBoxResult.No Then Exit Sub

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Me.BindingContext(dv).CancelCurrentEdit()

    End Sub

    Private Sub Button10_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click

        TextBox1.Focus()
        Me.BindingContext(dv).Position = dv.Count - 1

        Try
            'Aktuelle Bearbeitungen lschen
            Me.BindingContext(dv).EndCurrentEdit()
            Me.BindingContext(dv).AddNew()
        Catch eEndEdit As System.Exception
            System.Windows.Forms.MessageBox.Show(eEndEdit.Message)
        End Try
        Random1()

    End Sub


    Private Sub Random1()


        Dim z As New Random
        TextBox2.Text = (z.Next(1, 5000))

    End Sub

    Private Sub Zahlupdate()
        'Die Datenbankdateien werden mit einer neuen Zufallszahl
        'versehen, um sie dann erneut vernder nach 
        'Zufallszahl sortiert aufrufen zu knnen
        Random1()
        Me.BindingContext(dv).Position += 1
        Me.BindingContext(dv).EndCurrentEdit()


        Try
            'Versuch, die Datenquelle zu aktualisieren.
            If ds.HasChanges Then

                Dim m As Integer = da.Update(ds, "Worte")

            End If

        Catch eUpdate As System.Exception
            Exit Try
            'Fehlermeldung anzeigen, falls verfgbar.
            System.Windows.Forms.MessageBox.Show(eUpdate.Message)
        End Try

        If Me.BindingContext(dv).Position = Me.BindingContext(dv).Count - 1 Then     ' >|
            Timer1.Enabled = False
            Me.DataGridView1.DataSource = dv

            Me.BindingContext(dv).Position = 0   ' |<

        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Me.BindingContext(dv).Position = dv.Count - 1
        Zahlzeigen()

    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Me.BindingContext(dv).Position += 10
        Zahlzeigen()

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Me.BindingContext(dv).Position += 1
        Zahlzeigen()

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.BindingContext(dv).Position -= 1
        Zahlzeigen()

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Me.BindingContext(dv).Position -= 10
        Zahlzeigen()

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.BindingContext(dv).Position = 0
        Zahlzeigen()

    End Sub
    
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Zahlupdate()
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        MsgBox("Erzeugt neue Zufallszahlen!")
        'Beschleunigt das Erzeugen neuer Zufallszahlen
        Me.DataGridView1.DataSource = Nothing

        Me.BindingContext(dv).Position = 0
        Timer1.Enabled = True
    End Sub

    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        Timer1.Enabled = False
    End Sub

    Private Sub TextBox1_KeyPress1(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        If CheckBox1.Checked = False Then
            Select Case Asc(e.KeyChar)

                'Erlaubt das Einfgen aller Buchstaben auer Umlauten
                Case 65 To 90, 8, 32
                Case 97 To 122

                Case Else
                    ' alle anderen Eingaben unterdrcken
                    e.Handled = True
                    MsgBox("nicht zulssig!")
            End Select
        End If

      
    End Sub

    Private Sub DataGridView1_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellClick
        Zahlzeigen()
    End Sub

   
    Private Sub DataGridView1_CellFormatting(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellFormattingEventArgs) Handles DataGridView1.CellFormatting


        If DataGridView1.Columns(e.ColumnIndex).Name = "Begriff" Then
            e.CellStyle.ForeColor = Color.White
            e.CellStyle.BackColor = Color.Black

        End If
    End Sub

    Private Sub TextBox4_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox4.TextChanged
        dv.RowFilter = ""
        dv.RowFilter = "Begriff LIKE '" + Me.TextBox4.Text + "%'"
        dv.Sort = "Begriff"
        Zahlzeigen()
        If dv.Count = 0 Then MsgBox("Keinen Begriff " & TextBox4.Text & " gefunden!!")


    End Sub

   
    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        dv.RowFilter = ""
        dv.Sort = "Begriff"

    End Sub

   

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        Panel1.Visible = True
        Doubletten()
    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        Panel1.Visible = False
        Clear()
        dv.RowFilter = ""
        dv.Sort = "ID"

    End Sub

    Private Sub Doubletten()
        connString1 = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Application.StartupPath & "\Hnger.mdb"

        Dim conn1 As New OleDb.OleDbConnection(connString)
        'Hier werden Mehrfacheintrge von gleichenBegriffen ermittelt
        Dim sql As String = "SELECT Begriff, Count(ID) FROM Worte GROUP BY Begriff HAVING COUNT(ID) > 1"

        da1 = New OleDb.OleDbDataAdapter(sql, conn1)

        Try

            da1.Fill(ds1, "Worte")
        Catch ex As System.Exception
            MsgBox(ex.ToString())
            Return
        End Try
        dv1 = ds1.Tables("Worte").DefaultView

        DataGridView2.DataSource = dv1

    End Sub

    Private Sub DataGridView2_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView2.CellClick
        dv.RowFilter = ""
        dv.RowFilter = "Begriff LIKE '" + DataGridView2.Rows.Item(DataGridView2.CurrentRow.Index).Cells.Item(0).Value + "%'"
        dv.Sort = "Begriff"

    End Sub

    Private Sub Clear()
        DataGridView2.DataSource = Nothing

    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged

        'ersetzt die Umlaute und unerwnschte Zeichen beim Kopieren
        Dim S As String = TextBox1.Text
        S = S.Replace("", "ae") : S = S.Replace("", "oe") : S = S.Replace("", "ue")
        S = S.Replace("", "AE") : S = S.Replace("", "OE") : S = S.Replace("", "UE")
        S = S.Replace("", "ss") : S = S.Replace(",", "") : S = S.Replace(".", "")
        TextBox1.Text = S


    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        TextBox1.Focus()

    End Sub

    
End Class